using Harmony;
using RimWorld;
using System;
using System.Linq;
using System.Collections.Generic;
using System.Reflection;
using RimWorld.Planet;
using UnityEngine;
using Verse;
using Verse.AI;

namespace StorageTweaks
{
	//public override IEnumerable<InspectTabBase> GetInspectTabs()
	[HarmonyPatch(typeof(Building_Storage))]
	[HarmonyPatch("GetInspectTabs")]
	public static class Building_Storage_GetInspectTabs_Patch
	{
		
		public static IEnumerable<InspectTabBase> getTabs(IEnumerable<InspectTabBase> oldTabs)
		{
			foreach(InspectTabBase oldTab in oldTabs)
			{
				yield return oldTab;
			}

			yield return StorageTweaks.inspectorTab;
		}
		
		[HarmonyPostfix]
		public static void GetInspectTabs_Postfix(Thing __instance, ref IEnumerable<InspectTabBase> __result)
		{
			//Log.Message("HI2: " + __instance);
			if(__instance as Building_Storage != null)
			{
				__result = getTabs(__result);
			}
		}
		
	}
	
	//public override void ExposeData()
	[HarmonyPatch(typeof(Building_Storage))]
	[HarmonyPatch("ExposeData")]
	public static class Building_Storage_ExposeData_Patch
	{
		
		[HarmonyPostfix]
		public static void ExposeData_Postfix(Building_Storage __instance)
		{
			//Log.Message("HI: " + __instance);
			StorageTweaksData data = StorageTweaks.registry.data(__instance);
			data.ExposeData();
		}
		
	}
}