using Harmony;
using RimWorld;
using System;
using System.Linq;
using System.Collections.Generic;
using System.Reflection;
using RimWorld.Planet;
using UnityEngine;
using Verse;
using Verse.AI;

namespace StorageTweaks
{
	//private bool ShouldBeMergeable(Thing t)
	[HarmonyPatch(typeof(ListerMergeables))]
	[HarmonyPatch("ShouldBeMergeable")]
	public static class ListerMergeables_ShouldBeMergeable_Patch
	{
		[HarmonyPostfix]
		public static void Postfix(Thing t, ref bool __result)
		{
			if(t.GetSlotGroup() == null)
			{
				return;
			}
			
			StorageTweaksData storageTweaksData = StorageTweaks.registry.data(t.GetSlotGroup().parent as ISlotGroupParent);
			if(storageTweaksData.mergingDelay > 0)
			{
				// Log.Message("A: " + t + storageTweaksData.mergingDelay);
				
				if(storageTweaksData.mergingDelay == 13 ||
					storageTweaksData.lastMergingTick > Find.TickManager.TicksGame + storageTweaksData.mergingDelay * 60
				)
				{
					__result = false;
					return;
				}
				
				// Log.Message("B: " + storageTweaksData.mergingDelay);
				
				storageTweaksData.lastMergingTick = Find.TickManager.TicksGame + storageTweaksData.mergingDelay * 60;
			}
		}
		
	}
}