using Harmony;
using RimWorld;
using System;
using System.Linq;
using System.Collections.Generic;
using System.Reflection;
using RimWorld.Planet;
using UnityEngine;
using Verse;
using Verse.AI;

namespace StorageTweaks
{
	//public override IEnumerable<InspectTabBase> GetInspectTabs()
	[HarmonyPatch(typeof(Zone_Stockpile))]
	[HarmonyPatch("GetInspectTabs")]
	public static class Zone_Stockpile_GetInspectTabs_Patch
	{
		
		public static IEnumerable<InspectTabBase> getTabs(IEnumerable<InspectTabBase> oldTabs)
		{
			foreach(InspectTabBase oldTab in oldTabs)
			{
				yield return oldTab;
			}

			yield return StorageTweaks.inspectorTab;
		}
		
		[HarmonyPostfix]
		public static void GetInspectTabs_Postfix(ref Zone_Stockpile __instance, ref IEnumerable<InspectTabBase> __result)
		{
			__result = getTabs(__result);
		}
		
	}
	
	//public override void ExposeData()
	[HarmonyPatch(typeof(Zone_Stockpile))]
	[HarmonyPatch("ExposeData")]
	public static class Zone_Stockpile_ExposeData_Patch
	{
		
		[HarmonyPostfix]
		public static void ExposeData_Postfix(Zone_Stockpile __instance)
		{
			StorageTweaksData data = StorageTweaks.registry.data(__instance);
			data.ExposeData();
		}
		
	}
}